jQuery.noConflict();

/**
 * Firefox-Specific Functions
 */
var resourceUrl;
var locStrings;

self.port.on("resourceUrl", function (url) {
    resourceUrl = url;
});

self.port.on("l10nStrings", function (s) {
    locStrings = s;
});

self.port.on("storageObject", function (storage) {
    tmpStorage = storage;
    setPrivacyVisualizerPrefs();
    checkIfActive();
});

self.port.on("processPage", function () {
    addObserver();
    processPage();
});

self.port.on("clearPage", function () {
    clearPage();
});

function getLocString(n) {
    if (locStrings[n]) {
        return locStrings[n];
    }
    return "(Unknown String)";
}

function getFileUrl(name) {
    return resourceUrl + name;
}

/************************************************************************/


/**
 * Check if the addon is active
 */
function checkIfActive() {
    getPref("active", function (v) {
        if (v === true) {
            addObserver();
            processPage();
        }
    });
}