var feedbackUrl = "http://www.daniel-puscher.de/fpw/feedback.php";

function randomString(length) {
    length = (length || 10);

    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < length; i++)
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}

function encryptAES(input){
    var aes = new pidCrypt.AES.CBC();
    //encrypt the plaintext and returns the encrypted text
    //parameters: plaintext(String), password(String) and options
    var pwd = randomString(60);
    var crypted = aes.encryptText(input, pwd, {nBits: 256});

    return {
        crypted: crypted,
        pwd: pwd
    };
}

function encryptRSA(input) {
    var public_key = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQClN3/3ega4kLbxzg2swFy8AhH1hoUx0sy418ZwAWi0LD0haUXN2f4izEDueyUktxJa73rjT/ypPeZ8iDQAb6rkUqhEH5KuGHfOnDnvg2jzPriKrulaN6zKP64QdFBOKcYA/HDqPYbwAUX0o+FMnXUlrTOmkHI34IXZFtxwJ9YbhQIDAQAB";
    var key = pidCryptUtil.decodeBase64(public_key);
    //new RSA instance
    var rsa = new pidCrypt.RSA();
    //RSA encryption
    //ASN1 parsing
    var asn = pidCrypt.ASN1.decode(pidCryptUtil.toByteArray(key));
    //setting the public key for encryption
    rsa.setPublicKeyFromASN(asn.toHexTree());
    var crypted = rsa.encrypt(input);
    return pidCryptUtil.encodeBase64(pidCryptUtil.convertFromHex(crypted));
}

function generateStorageJSON() {
    var storageNames = ["active", "animate", "background", "border", "cache", "filled", "firstStart", "initial", "installationID", "lastStartVersion", "showHelp", "stats", "useImages"];
    var storage = {};
    jQuery.each(storageNames, function (k, v) {
        k = v;
        v = tmpStorage[v];
        if (k === "cache" || k === "filled" || k === "initial") {
            v = sha1Keys(v);
        }
        storage[k] = v;
    });
    return JSON.stringify(storage);
}

function sha1Keys(obj) {
    var keys = Object.keys(obj);
    for (var i in keys) {
        var key = keys[i];
        var hashedKey = jQuery.sha1(key);

        obj[hashedKey] = obj[key];
        delete obj[key];
    }
    return obj;
}

function sendFeedback() {
    var encrypted_storage = encryptAES(generateStorageJSON());

    jQuery.post(feedbackUrl, "storageData=" + encodeURIComponent(encrypted_storage.crypted) + "&pwd=" + encodeURIComponent(encryptRSA(encrypted_storage.pwd)) + "&" + jQuery("#fpwFeedback").serialize())
        .done(function (data) {
            showSuccess(getLocString("feedbackSuccess"));
        })
        .fail(function(data) {
            showError(getLocString("feedbackError")+"<br><br>\""+data.responseText+"\"");
            jQuery("#submit").button("enable");
        });
}

function notification(text, type) {
    noty({text: text,
        layout: "center",
        dismissQueue: false,
        timeout: 5000,
        closeWith: ['button', 'click'],
        type: type
    });
}

function showSuccess(text){
    notification(text, 'success');
}

function showError(text){
    notification(text, 'error');
}

function initFeedback(){
    jQuery("a").attr("target", "_blank");

    jQuery("#fbLink").attr("href", "http://www.facebook.com/privacywatcher");
    jQuery("#emailLink").attr("href", 'mailto:fpw@daniel-puscher.de').removeAttr("target");
    jQuery(".buttonSet").buttonset();
    jQuery("textarea").addClass("ui-widget ui-state-default ui-corner-all").css({
        "background": "none",
        "backgroundColor": "#F8F8F8"
    });

    jQuery("#submit").button().click(function(e){
        e.preventDefault();
        jQuery(this).button('disable');
        sendFeedback();
    });

    jQuery('textarea[maxlength]').keyup(function(){
        var limit = parseInt($(this).attr('maxlength'));
        var text = $(this).val();
        var chars = text.length;
        if(chars > limit){
            var new_text = text.substr(0, limit);
            $(this).val(new_text);
        }
    });

}

self.port.on("l10nStrings", function(s) {
    locStrings = s;
    loadI18nStrings();
    initFeedback();
} );

function getLocString(n){
    if(locStrings[n]){
        return locStrings[n];
    }
    return "(Unknown String)";
}

self.port.on("storageObject", function (storage) {
    tmpStorage = storage;
});
